(*       Demo of DebugMe Message system in use for DOS target.

         The actual message places into the message stack can be
         ANYTHING YOU DESIRE, you can choose to include variable values
         or anything else that you think may help you.

         Demonstration of a simple runtime error.
         It locates the procedure/function where the error occurred.

*)

uses
  DebugMe;

procedure Task5;
begin
  Set_Debug_Message('Task5 is being executed');  {put the procedure name onto the message stack}

  RunError(216);               {generate a critical fault}

  Remove_Debug_Message;        {now the procedure has finished, remove the message}
end;

procedure Task4;
begin
  Set_Debug_Message('Task4 is being executed');  {put the procedure name onto the message stack}

  task5;

  Remove_Debug_Message;        {now the procedure has finished, remove the message}
end;

procedure Task3;
begin
  Set_Debug_Message('Task3 is being executed');  {put the procedure name onto the message stack}

  task4;

  Remove_Debug_Message;        {now the procedure has finished, remove the message}
end;

procedure Task2;
begin
  Set_Debug_Message('Task2 is being executed');  {put the procedure name onto the message stack}

  Task3;

  Remove_Debug_Message;        {now the procedure has finished, remove the message}
end;

procedure Task1;
begin
  Set_Debug_Message('Task1 is being executed');  {put the procedure name onto the message stack}

  Task2;

  Remove_Debug_Message;        {now the procedure has finished, remove the message}
end;

begin
  Install_Error_Handler;           {install error handler}
  Debug_Messages_Enabled := true;  {enable message system}
  Error_Log := true;               {enable error logging}

  Task1;                           {do the tasks required}

  Uninstall_Error_Handler;         {remove the error handler}
end.